/********************************************************************** 
 Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
***********************************************************************/

#ifndef FC__GAME_H
#define FC__GAME_H

#include "shared.h"
#include "unit.h"
#include "city.h"
#include "tech.h"

struct civ_game {
  int version;
  int civstyle;
  int gold;
  int settlers, explorer;
  int tech;
  int skill_level;
  int timeout;
  int end_year;
  int year;
  int techlevel;
  int diplcost, freecost, conquercost;
  int diplchance;
  int cityfactor;
  int civilwarsize;
  int min_players, max_players, nplayers;
  int aifill;
  int unhappysize;
  char *startmessage;
  int player_idx;
#if 0
  struct player *player_ptr;
  struct player players[MAX_PLAYERS];
#endif
  int global_advances[A_LAST];             /* a counter */
  int global_wonders[B_LAST];              /* contains city id's */
  int globalwarming;                       /* counter of how disturbed 
					      mother nature is */
  int rail_food, rail_trade, rail_prod;
  int heating;
  int warminglevel;
  char save_name[MAX_LENGTH_NAME];
  int save_nturns;
  int scenario;
  int foodbox;
  int aqueductloss;
  int techpenalty;
  int razechance;
  int scorelog;
  int randseed;
  int aqueduct_size;
  int sewer_size;
  int spacerace;
  struct {
    char techs[MAX_LENGTH_NAME];
    char units[MAX_LENGTH_NAME];
    char buildings[MAX_LENGTH_NAME];
  } ruleset;
  int firepower_factor;		/* See README.rulesets */
  struct {
    int get_bonus_tech;		/* eg Philosophy */
    int boat_fast;		/* eg Nuclear Power */
    int cathedral_plus;		/* eg Theology */
    int cathedral_minus;	/* eg Communism */
    int colosseum_plus;		/* eg Electricity */
    int nav;			/* AI convenience: tech_req for first
				   non-trireme ferryboat */
  } rtech;
};

extern struct civ_game game;

#endif
