/********************************************************************** 
 Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
***********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <shared.h>

#ifndef FREECIV_DATADIR
#define FREECIV_DATADIR "data"
#endif

/***************************************************************
...
***************************************************************/
char *mystrdup(char *str)
{
  char *dest=malloc(strlen(str)+1);
  if(dest)
    strcpy(dest, str);
  return dest;
}

/***************************************************************************
Prepend the data directory to the filename to get the
relative path to a file in the data directory.
Use environment variable and check that its sane.
(Used to be in client/climisc.c)
The returned pointer points to static memory, so this can
only supply one filename at a time.
***************************************************************************/
char *datafilename(char *filename)
{
#if 1				/* mod for techtree */
  return filename;
#else
  static char* datadir=0;
  static char  realfile[512];
  if(!datadir) {
    if((datadir = getenv("FREECIV_DATADIR"))) {
      int i;
      for(i=strlen(datadir)-1; i>=0 && isspace((int)datadir[i]); i--)
	datadir[i] = '\0';
      if(datadir[i] == '/')
	datadir[i] = '\0';
    } else {
      datadir = FREECIV_DATADIR; /* correct if not 'data' is the default */
    };
  };
  sprintf(realfile,"%s/%s",datadir,filename);
  return(realfile);
#endif
}
