/********************************************************************** 
 techtree - Copyright (C) 1998 - David W. Pfitzner
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
***********************************************************************/

#include "extra.h"
#include "tech.h"
#include "game.h"

char* extras[A_LAST];

/* Note: only handle case of at most one 'extra' per tech */
void setup_extras(void)
{
    int i;
    
    for( i=0; i<A_LAST; i++ ) {
	extras[i] = 0;
    }
    extras[A_CONSTRUCTION] = "fortresses";
    extras[A_BRIDGE] = "bridges";
    if( tech_exists(game.rtech.get_bonus_tech) ) {
	extras[game.rtech.get_bonus_tech] = "+1 tech to 1st";
    }
    if( tech_exists(game.rtech.boat_fast) ) {
	extras[game.rtech.boat_fast] = "boats move +1";
    }
    if( tech_exists(game.rtech.cathedral_plus) ) {
	extras[game.rtech.cathedral_plus] = "cathedrals +1";
    }
    if( tech_exists(game.rtech.cathedral_minus) ) {
	extras[game.rtech.cathedral_minus] = "cathedrals -1";
    }
    if( tech_exists(game.rtech.colosseum_plus) ) {
	extras[game.rtech.colosseum_plus] = "colosseums +1";
    }
    extras[A_MONARCHY]
	= extras[A_REPUBLIC]
	= extras[A_COMMUNISM] 
	= extras[A_DEMOCRACY] 
	= "government";
}
