/********************************************************************** 
 techtree - Copyright (C) 1998 - David W. Pfitzner
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
***********************************************************************/

/* graph/topology metrics... */

#ifndef TT__METRICS_H
#define TT__METRICS_H

#include <stdio.h>

#include "techtree.h"

/* a geometrical distance: */
float dist_node_node( tech_node_t *node1, tech_node_t *node2 );
float dist_node_allow( tech_tree_t *ttree, tech_node_t *node );
float dist_node_req( tech_tree_t *ttree, tech_node_t *node );
float dist_node_links( tech_tree_t *ttree, tech_node_t *node );
float dist_tree( tech_tree_t *ttree );

/* link crossings: */
int cross_node_allow( tech_tree_t *ttree, tech_node_t *node );
int cross_node_req( tech_tree_t *ttree, tech_node_t *node );
int cross_node_links( tech_tree_t *ttree, tech_node_t *node );
int cross_tree( tech_tree_t *ttree );

/* geometrical distance * (1+crossings) for each link */
float distx_node_allow( tech_tree_t *ttree, tech_node_t *node );
float distx_node_req( tech_tree_t *ttree, tech_node_t *node );
float distx_node_links( tech_tree_t *ttree, tech_node_t *node );
float distx_tree( tech_tree_t *ttree );

void calc_tree_metrics( tech_tree_t *ttree );
void print_tree_metrics( FILE *fp, tech_tree_t *ttree, int id, char *str );
void calc_print_tree_metrics( FILE *fp, tech_tree_t *ttree, int id, char *str );
void print_tree_metrics_ps( FILE *fp, tech_tree_t *ttree );

#endif /* TT__METRICS_H */
