/********************************************************************** 
 techtree - Copyright (C) 1998 - David W. Pfitzner
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
***********************************************************************/

#ifndef TT__SORT_H
#define TT__SORT_H

#include "techtree.h"

typedef int (*qsort_arg_fn_t)( const void*, const void* );

/* qsort comparison functions:  */
int tcompare_levels( const void* i1, const void* i2 );
int tcompare_lev_dx( const void* i1, const void* i2 );
int tcompare_lev_i( const void* i1, const void* i2 );
int tcompare_dx( const void* i1, const void* i2 );

void sort_techtree_part( tech_tree_t *ttree, int *i_list, int n,
			 qsort_arg_fn_t tcompare );
void sort_techtree( tech_tree_t *ttree, qsort_arg_fn_t tcompare );

#endif /* TT__SORT_H */
